#ident  "@(#)history.awk  1.1  98/03/05  SMI"

BEGIN { 
	FS = "\t"
	fld = -1 
	dif = difcnt = cmtcnt = cmt = 0
	printf "#\t  Event type\t\t\tTime\t\t\tComment\n"
}

NR==2 {
	nevent = $1
	event = 0
	rec = mask
}
fld == 6 {		# final state
	if ( length(rec) == 0 )
		print line[0]
	#if ( difcnt < cmtcnt ) max = cmtcnt
	#else max = difcnt
	#for ( i=1 ; i < max ; i++ ) 
	   # print line[i]
	#print ""
	fld = -1
	cmtcnt = difcnt = 0 ;
}

fld == 5 { 		# comment
	#print "cmt line= " cmt ":" substr($0,0,24)
	line[cmt] = line[cmt] "\t" substr($0,0,35)
	#print substr($0,0,24)
	cmt += 1 
	if ( cmt == cmtcnt )
	    fld = 6 ;
	if ( fld == 6 ) {
	    if ( event == nevent - 0 ) {
		if ( length(rec) == 0 )
			print line[0]
		# exit
	    }
	}
	# if ( length(rec) > 0 ) {
		if ( rec == event ) print $0
	# }
}

fld == 4 { 		# comments line count
	if ( $1 == 0 ) {
	    line[0] = line[0] 
	    fld = 7
	    cmtcnt = 0 ;
	}
	else {
	    cmtcnt = $1
	    #print "cmtcnt= " cmtcnt
	    cmt = 0
	    fld = 5
	}
	if ( length(rec) > 0 ) {
		if ( rec == event ) {
			print "Comments : "
			if ( cmtcnt == 0 )
				print "none"
		}
	}
}

fld == 3 { 		# differences
	#if ( dif == 0 ) {
	    #if ( length($0) > 24 )
	    	#line[dif] = line[dif] "\t" substr($0,0,24)
	    #else
	    	#line[dif] = line[dif] "\t" substr($0,0,24) "\t"
	#}
	#else
	    #line[dif] = "\t\t\t\t\t\t\t" substr($0,0,24)
	dif += 1 ;
	if ( dif == difcnt )
	    fld = 4
	if ( length(rec) > 0 ) {
		if ( rec == event ) print $0
	}
}

fld == 2 { 		# diff line count
	if ( $1 == 0 ) {
	    fld = 4
	    #line[0] = line[0] "\t\t\t\t"
	    difcnt = 0 ;
	}
	else {
	    difcnt = $1 
	    #print "difcnt= " difcnt
	    dif = 0
	    fld = 3
	}
	if ( length(rec) > 0 ) {
		if ( rec == event ) {
			print "Differences detected :"
			if ( difcnt == 0 )
				print "none"
		}
	}
}

fld == 1 {
	line[0] = ""
	if ( length($2) > 15 )
	    line[0] = $1 "\t" $2 "\t" $3
	else
	    line[0] = $1 "\t" $2 "\t\t" $3
	if ( length(rec) > 0 ) {
		if ( rec == event ) print line[0]
	}
	fld = 2 
}

fld == 7 {		# final state without comment
	if ( length(rec) == 0 )
		print line[0]
	fld = -1
	cmtcnt = difcnt = 0 ;
}

$1 == "~" {
	fld = 1
	event++
	notyet = 1 ;
}

END {
}
